#include "PROGRAM\\Reports.cpp"

#define REP101_ST_OBJINIT 0
#define REP101_ST_SUMMARY 1
#define REP101_ST_LOG 2
#define REP101_ST_EXPORT 3
#define REP101_ST_OBJCOMPLETE 4

//     "ArchParams.fr3"
//     
int rep101_timeIntID; //   
TDateTime rep101_sdt; //  /
TDateTime rep101_edt; //  /
Variant rep101_objArray; //     
bool rep101_needSummary; //  ""
bool rep101_needLog; //  
bool rep101_needExport; //    

//  
bool rep101_needRep;
string rep101_expDir;

TADOConnection rep101_cnExp;
TADOQuery rep101_qryPrepData;
TADOQuery rep101_qryObjects;
TADOQuery rep101_qryVDevices;
TADOQuery rep101_qrySummary;
TADOQuery rep101_qryLog;
TADOQuery rep101_qryLogAgr;
TADOQuery rep101_qryInt;
TADOQuery rep101_qryIntAgr;
TADOQuery rep101_qryExpDailySrc;
TADOQuery rep101_qryExpDailyDst;
TADOQuery rep101_qryExpAgrSrc;
TADOQuery rep101_qryExpAgrDst;

TfrxDBDataset rep101_dsObjects;
TfrxDBDataset rep101_dsVDevices;
TfrxDBDataset rep101_dsSummary;
TfrxDBDataset rep101_dsLog;
TfrxDBDataset rep101_dsLogAgr;
TfrxDBDataset rep101_dsInt;
TfrxDBDataset rep101_dsIntAgr;

string rep101_qryPrepDataSQL1;
string rep101_qryPrepDataSQL2;
string rep101_qryObjectsSQL;
string rep101_qryVDevicesSQL;
string rep101_qrySummarySQL;
string rep101_qryLogSQL;
string rep101_qryLogAgrSQL;
string rep101_qryIntSQL;
string rep101_qryIntAgrSQL;
string rep101_qryExpDailySrcSQL;
string rep101_qryExpAgrSrcSQL;
string rep101_qryExpDstSQL;

void Rep101_ClearPrepared()
{
  DeleteFile(rep_prepDir + rep_repID + "\\Part*.fp3");
  DeleteFile(rep_prepDir + rep_repID + "\\Files.csv");
  DeleteFile(rep101_expDir + "*.dbf");
}

void Rep101_InitVars()
{
  rep101_cmdStart.Text = "-  ";
  rep101_expDir = rep_frDir + "Export\\EIRC\\";

  rep101_cnExp = nil;
  rep101_qryPrepData = nil;
  rep101_qryObjects = nil;
  rep101_qryVDevices = nil;
  rep101_qrySummary = nil;
  rep101_qryLog = nil;
  rep101_qryLogAgr = nil;
  rep101_qryInt = nil;
  rep101_qryIntAgr = nil;
  rep101_qryExpDailySrc = nil;
  rep101_qryExpDailyDst = nil;
  rep101_qryExpAgrSrc = nil;
  rep101_qryExpAgrDst = nil;

  rep101_dsObjects = nil;
  rep101_dsVDevices = nil;
  rep101_dsSummary = nil;
  rep101_dsLog = nil;
  rep101_dsLogAgr = nil;
  rep101_dsInt = nil;
  rep101_dsIntAgr = nil;

  rep101_qryPrepDataSQL1 = "SELECT rep101_init(%d, '%s', '%s', %s, %s, %s)";
  rep101_qryPrepDataSQL2 = "SELECT rep101_prep_object(:objid)";
  rep101_qryObjectsSQL = "SELECT * FROM tmp_rep101_objects WHERE objid = :objid";
  rep101_qryVDevicesSQL =
    "SELECT * FROM tmp_rep101_vdevices WHERE objid = :objid ORDER BY vdevnum";
  rep101_qrySummarySQL =
    "SELECT * FROM tmp_rep101_summary WHERE objid = :objid ORDER BY vdevnum, uorder";
  rep101_qryLogSQL = "SELECT * FROM %s WHERE vdevnum = %d ORDER BY dt";
  rep101_qryLogAgrSQL = "SELECT * FROM %s WHERE vdevnum = %d";
  rep101_qryIntSQL =
    "SELECT * FROM %s WHERE vdevnum = %d AND dt IS NOT NULL AND v ORDER BY dt DESC";
  rep101_qryIntAgrSQL = "SELECT * FROM %s WHERE vdevnum = %d AND dt IS NULL";

  rep101_qryExpDailySrcSQL = "SELECT * FROM tmp_rep101_exp_daily WHERE npp IN " +
    "(SELECT vdevnum FROM tmp_rep101_vdevices WHERE objid = :objid) " +
    "ORDER BY npp, date_p, k_u";
  rep101_qryExpAgrSrcSQL = "SELECT * FROM tmp_rep101_exp_agr WHERE npp IN " +
    "(SELECT vdevnum FROM tmp_rep101_vdevices WHERE objid = :objid) " +
    "ORDER BY npp";
  rep101_qryExpDstSQL = "SELECT * FROM %s WHERE FALSE";
}

void Rep101_InitTasks()
{
  int i = 0; rep_tasks[i] = REP101_ST_OBJINIT;
  if (rep101_needSummary) {i++; rep_tasks[i] = REP101_ST_SUMMARY;}
  if (rep101_needLog) {i++; rep_tasks[i] = REP101_ST_LOG;}
  if (rep101_needExport) {i++; rep_tasks[i] = REP101_ST_EXPORT;}
  i++; rep_tasks[i] = REP101_ST_OBJCOMPLETE;
}

void Rep101_InitCommonObjects()
{
  //     
  rep101_qryPrepData = new TADOQuery(nil);
  rep101_qryPrepData.Connection = SystemADOConnection;
  rep101_qryPrepData.LockType = 1;
  rep101_qryPrepData.SQL.Text = Format(rep101_qryPrepDataSQL1,
    [
      rep101_timeIntID,
      FormatDateTime("yyyy-mm-dd hh:nn:ss", rep101_sdt),
      FormatDateTime("yyyy-mm-dd hh:nn:ss", rep101_edt),
      Rep_GetBoolStr(rep101_needSummary),
      Rep_GetBoolStr(rep101_needLog),
      Rep_GetBoolStr(rep101_needExport)
    ]);

  //   
  rep101_qryPrepData.Open();
  rep101_qryPrepData.Close();

  rep101_qryPrepData.SQL.Text = rep101_qryPrepDataSQL2;
  rep101_qryPrepData.Parameters.Items[0].DataType = ftInteger;

  //  
  rep101_qryObjects = new TADOQuery(nil);
  rep101_qryObjects.Connection = SystemADOConnection;
  rep101_qryObjects.SQL.Text = rep101_qryObjectsSQL;
  rep101_qryObjects.Parameters.Items[0].DataType = ftInteger;

  rep101_dsObjects = new TfrxDBDataset(nil);
  rep101_dsObjects.DataSet = rep101_qryObjects;
  rep101_dsObjects.Name = "dsObjects";

  //  
  rep101_qryVDevices = new TADOQuery(nil);
  rep101_qryVDevices.Connection = SystemADOConnection;
  rep101_qryVDevices.SQL.Text = rep101_qryVDevicesSQL;
  rep101_qryVDevices.Parameters.Items[0].DataType = ftInteger;

  rep101_dsVDevices = new TfrxDBDataset(nil);
  rep101_dsVDevices.DataSet = rep101_qryVDevices;
  rep101_dsVDevices.Name = "dsVDevices";
}

void Rep101_UninitCommonObjects()
{
  if (rep101_qryPrepData != nil) {delete rep101_qryPrepData; rep101_qryPrepData = nil;}
  if (rep101_qryObjects != nil) {delete rep101_qryObjects; rep101_qryObjects = nil;}
  if (rep101_dsObjects != nil) {delete rep101_dsObjects; rep101_dsObjects = nil;}
  if (rep101_qryVDevices != nil) {delete rep101_qryVDevices; rep101_qryVDevices = nil;}
  if (rep101_dsVDevices != nil) {delete rep101_dsVDevices; rep101_dsVDevices = nil;}
}

void Rep101_InitSummaryObjects()
{
  if (!rep101_needSummary) return;

  //   ""
  rep101_qrySummary = new TADOQuery(nil);
  rep101_qrySummary.Connection = SystemADOConnection;
  rep101_qrySummary.SQL.Text = rep101_qrySummarySQL;
  rep101_qrySummary.Parameters.Items[0].DataType = ftInteger;

  rep101_dsSummary = new TfrxDBDataset(nil);
  rep101_dsSummary.DataSet = rep101_qrySummary;
  rep101_dsSummary.Name = "dsSummary";
  rep101_dsSummary.CloseDataSource = true;
}

void Rep101_UninitSummaryObjects()
{
  if (!rep101_needSummary) return;

  if (rep101_qrySummary != nil) {delete rep101_qrySummary; rep101_qrySummary = nil;}
  if (rep101_dsSummary != nil) {delete rep101_dsSummary; rep101_dsSummary = nil;}
}

void Rep101_InitLogObjects()
{
  if (!rep101_needLog) return;

  //  
  rep101_qryLog = new TADOQuery(nil);
  rep101_qryLog.Connection = SystemADOConnection;

  rep101_dsLog = new TfrxDBDataset(nil);
  rep101_dsLog.DataSet = rep101_qryLog;
  rep101_dsLog.Name = "dsLog";
  rep101_dsLog.CloseDataSource = true;

  //   ()
  rep101_qryLogAgr = new TADOQuery(nil);
  rep101_qryLogAgr.Connection = SystemADOConnection;

  rep101_dsLogAgr = new TfrxDBDataset(nil);
  rep101_dsLogAgr.DataSet = rep101_qryLogAgr;
  rep101_dsLogAgr.Name = "dsLogAgr";
  rep101_dsLogAgr.CloseDataSource = true;

  // 
  rep101_qryInt = new TADOQuery(nil);
  rep101_qryInt.Connection = SystemADOConnection;

  rep101_dsInt = new TfrxDBDataset(nil);
  rep101_dsInt.DataSet = rep101_qryInt;
  rep101_dsInt.Name = "dsInt";
  rep101_dsInt.CloseDataSource = true;

  //  ()
  rep101_qryIntAgr = new TADOQuery(nil);
  rep101_qryIntAgr.Connection = SystemADOConnection;

  rep101_dsIntAgr = new TfrxDBDataset(nil);
  rep101_dsIntAgr.DataSet = rep101_qryIntAgr;
  rep101_dsIntAgr.Name = "dsIntAgr";
  rep101_dsIntAgr.CloseDataSource = true;
}

void Rep101_UninitLogObjects()
{
  if (!rep101_needLog) return;

  if (rep101_qryLog != nil) {delete rep101_qryLog; rep101_qryLog = nil;}
  if (rep101_dsLog != nil) {delete rep101_dsLog; rep101_dsLog = nil;}
  if (rep101_qryLogAgr != nil) {delete rep101_qryLogAgr; rep101_qryLogAgr = nil;}
  if (rep101_dsLogAgr != nil) {delete rep101_dsLogAgr; rep101_dsLogAgr = nil;}
  if (rep101_qryInt != nil) {delete rep101_qryInt; rep101_qryInt = nil;}
  if (rep101_dsInt != nil) {delete rep101_dsInt; rep101_dsInt = nil;}
  if (rep101_qryIntAgr != nil) {delete rep101_qryIntAgr; rep101_qryIntAgr = nil;}
  if (rep101_dsIntAgr != nil) {delete rep101_dsIntAgr; rep101_dsIntAgr = nil;}
}

void Rep101_InitExportObjects()
{
  if (!rep101_needExport) return;

  string tmplDir = rep_frDir + "DBF\\";
  string dailyFileName = "daily";
  string agrFileName = "totals";

  if (!FileCopy(tmplDir + "tmpl_exp_daily.dbf", rep101_expDir + dailyFileName + ".dbf"))
    RaiseException("    FileCopy()");
  if (!FileCopy(tmplDir + "tmpl_exp_totals.dbf", rep101_expDir + agrFileName + ".dbf"))
    RaiseException("    FileCopy()");

  rep101_cnExp = new TADOConnection(nil);
  rep101_cnExp.ConnectionString =
    "Provider=Microsoft.Jet.OLEDB.4.0;" +
    "Data Source=" + rep101_expDir + ";" +
    "Extended Properties=dBASE III;";
  rep101_cnExp.LoginPrompt = false;
  rep101_cnExp.Connected = true;

  rep101_qryExpDailySrc = new TADOQuery(nil);
  rep101_qryExpDailySrc.Connection = SystemADOConnection;
  rep101_qryExpDailySrc.SQL.Text = rep101_qryExpDailySrcSQL;
  rep101_qryExpDailySrc.Parameters.Items[0].DataType = ftInteger;

  rep101_qryExpDailyDst = new TADOQuery(nil);
  rep101_qryExpDailyDst.Connection = rep101_cnExp;
  rep101_qryExpDailyDst.SQL.Text = Format(rep101_qryExpDstSQL, [dailyFileName]);

  rep101_qryExpAgrSrc = new TADOQuery(nil);
  rep101_qryExpAgrSrc.Connection = SystemADOConnection;
  rep101_qryExpAgrSrc.SQL.Text = rep101_qryExpAgrSrcSQL;
  rep101_qryExpAgrSrc.Parameters.Items[0].DataType = ftInteger;

  rep101_qryExpAgrDst = new TADOQuery(nil);
  rep101_qryExpAgrDst.Connection = rep101_cnExp;
  rep101_qryExpAgrDst.SQL.Text = Format(rep101_qryExpDstSQL, [agrFileName]);
}

void Rep101_UninitExportObjects()
{
  if (!rep101_needExport) return;

  if (rep101_qryExpDailySrc != nil) {delete rep101_qryExpDailySrc; rep101_qryExpDailySrc = nil;}
  if (rep101_qryExpDailyDst != nil) {delete rep101_qryExpDailyDst; rep101_qryExpDailyDst = nil;}
  if (rep101_qryExpAgrSrc != nil) {delete rep101_qryExpAgrSrc; rep101_qryExpAgrSrc = nil;}
  if (rep101_qryExpAgrDst != nil) {delete rep101_qryExpAgrDst; rep101_qryExpAgrDst = nil;}
  if (rep101_cnExp != nil) {delete rep101_cnExp; rep101_cnExp = nil;}
}

//    
void Rep101_Init()
{
  Rep_InitProgress(Length(rep101_objArray), Rep101_cmdStart);
  Rep_DisplayProgress();

  Rep101_ClearPrepared();
  rep101_needRep = rep101_needSummary || rep101_needLog;
  if (rep101_needRep) Rep_InitPrepared();

  Rep101_InitTasks();

  Rep101_InitCommonObjects();
  Rep101_InitSummaryObjects();
  Rep101_InitLogObjects();
  Rep101_InitExportObjects();
}

//    
void Rep101_Uninit()
{
  Rep_UninitProgress(Rep101_cmdStart);
  if (rep101_needRep) Rep_UninitPrepared();

  Rep101_UninitCommonObjects();
  Rep101_UninitSummaryObjects();
  Rep101_UninitLogObjects();
  Rep101_UninitExportObjects();

  Rep_Uninit();
}

//    DBF  
void Rep101_ExportToDBF(int objID)
{
  try
  {
    try
    {
      rep101_cnExp.BeginTrans();

      rep101_qryExpDailySrc.Parameters.Items[0].Value = objID;
      rep101_qryExpDailySrc.Open();
      rep101_qryExpDailyDst.Open();

      rep101_qryExpAgrSrc.Parameters.Items[0].Value = objID;
      rep101_qryExpAgrSrc.Open();
      rep101_qryExpAgrDst.Open();
      int i;

      for (; !rep101_qryExpDailySrc.EOF; rep101_qryExpDailySrc.Next())
      {
        rep101_qryExpDailyDst.Append();

        for (i = 0; i < rep101_qryExpDailySrc.FieldCount; i++)
          rep101_qryExpDailyDst.Fields.Fields[i].Value =
            rep101_qryExpDailySrc.Fields.Fields[i].Value;

        rep101_qryExpDailyDst.Post();
        Application.ProcessMessages();
        Sleep(0);
      }

      for (; !rep101_qryExpAgrSrc.EOF; rep101_qryExpAgrSrc.Next())
      {
        rep101_qryExpAgrDst.Append();

        for (i = 0; i < rep101_qryExpAgrSrc.FieldCount; i++)
          rep101_qryExpAgrDst.Fields.Fields[i].Value =
            rep101_qryExpAgrSrc.Fields.Fields[i].Value;

        rep101_qryExpAgrDst.Post();
        Application.ProcessMessages();
        Sleep(0);
      }

      rep101_cnExp.CommitTrans();
    }
    except
    {
      Rep_ReportException();
      rep101_cnExp.RollbackTrans();
    }
  }
  finally
  {
    rep101_qryExpDailySrc.Close();
    rep101_qryExpDailyDst.Close();
    rep101_qryExpAgrSrc.Close();
    rep101_qryExpAgrDst.Close();
  }
}

//    
void Rep101_PrepareNext()
{
  int objID;
  string fullAddr;
  string objName;
  TfrxMasterData b;

  while (true)
    switch (rep_task)
    {
      case REP101_ST_OBJINIT:
      {
        ProcessMessages();

        if (rep_break)
          Rep_ReportInfo(REP_MSG_USERBREAK);

        if ((rep_objCount >= rep_totalObjs) || rep_break)
        {
          Rep_SetTask(REP_ST_COMPLETE);
          continue;
        }

        objID = rep101_objArray[rep_objCount];
        rep101_qryPrepData.Parameters.Items[0].Value = objID;

        try
        {
          rep101_qryPrepData.Open();
        }
        except
        {
          Rep_ReportException();
          Rep_SetTask(REP101_ST_OBJCOMPLETE);
          continue;
        }

        rep101_qryObjects.Parameters.Items[0].Value = objID;
        rep101_qryObjects.Open();

        rep101_qryVDevices.Parameters.Items[0].Value = objID;
        rep101_qryVDevices.Open();

        fullAddr = rep101_qryObjects.FieldByName("addr").AsString;
        objName = rep101_qryObjects.FieldByName("objname").AsString;
        if (Length(objName) > 0) fullAddr = fullAddr + " " + objName;
        Rep_WriteLog(fullAddr);

        if (rep101_needRep && rep_isSaved)
          rep_firstObjName = fullAddr;

        Rep_SetNextTask();
        continue;
      }

      case REP101_ST_SUMMARY:
      {
        rep101_qrySummary.Parameters.Items[0].Value = objID;

        //   
        rep_newTmplFileName = "Rep101_Summary.fr3";

        if (rep_newTmplFileName != rep_curTmplFileName)
        {
          if (!Rep_LoadTemplate(rep_tmplDir + rep_newTmplFileName))
          {
            Rep_SetNextTask();
            continue;
          }

          //     
          SystemReport.DataSets.Add(rep101_dsObjects);
          SystemReport.DataSets.Add(rep101_dsSummary);
          //     
          b = TfrxMasterData(SystemReport.FindObject("bandSummary"));
          if (b != nil) b.DataSet = rep101_dsSummary;
        }

        //      () 
        Rep_AsyncPrepare(rep_isSaved, "Rep101_OnComplete");
        return;
      }

      case REP101_ST_LOG:
      {
        if (rep101_qryVDevices.EOF)
        {
          Rep_SetNextTask();
          continue;
        }

        Rep_WriteLog
        (
          rep101_qryVDevices.FieldByName("systemabbr").AsString + ", " +
          rep101_qryVDevices.FieldByName("typename").AsString + ", " +
          " " + rep101_qryVDevices.FieldByName("sernum").AsString
        );

        rep_newTmplFileName = AsString(rep101_qryVDevices.FieldByName("repfile").Value);

        if (rep_newTmplFileName == "")
        {
          rep101_qryVDevices.Next();
          continue;
        }

        int vDevNum = AsInteger(rep101_qryVDevices.FieldByName("vdevnum").Value);

        rep101_qryLog.SQL.Text = Format(rep101_qryLogSQL,
          [AsString(rep101_qryVDevices.FieldByName("logtblname").Value), vDevNum]);
        rep101_qryLogAgr.SQL.Text = Format(rep101_qryLogAgrSQL,
          [AsString(rep101_qryVDevices.FieldByName("agrtblname").Value), vDevNum]);
        rep101_qryInt.SQL.Text = Format(rep101_qryIntSQL,
          [AsString(rep101_qryVDevices.FieldByName("inttblname").Value), vDevNum]);
        rep101_qryIntAgr.SQL.Text = Format(rep101_qryIntAgrSQL,
          [AsString(rep101_qryVDevices.FieldByName("inttblname").Value), vDevNum]);

        //   
        if (rep_newTmplFileName != rep_curTmplFileName)
        {
          if (!Rep_LoadTemplate(rep_tmplDir + rep_newTmplFileName))
          {
            rep101_qryVDevices.Next();
            continue;
          }

          //     
          SystemReport.DataSets.Add(rep101_dsObjects);
          SystemReport.DataSets.Add(rep101_dsVDevices);
          SystemReport.DataSets.Add(rep101_dsLog);
          SystemReport.DataSets.Add(rep101_dsLogAgr);
          SystemReport.DataSets.Add(rep101_dsInt);
          SystemReport.DataSets.Add(rep101_dsIntAgr);
          //     
          b = TfrxMasterData(SystemReport.FindObject("bandLog"));
          if (b != nil) b.DataSet = rep101_dsLog;
          b = TfrxMasterData(SystemReport.FindObject("bandInt"));
          if (b != nil) b.DataSet = rep101_dsInt;
        }

        //      () 
        Rep_AsyncPrepare(rep_isSaved, "Rep101_OnComplete");
        return;
      }

      case REP101_ST_EXPORT:
      {
        Rep101_ExportToDBF(objID);
        Rep_SetNextTask();
        continue;
      }

      case REP101_ST_OBJCOMPLETE:
      {
        rep101_qryVDevices.Close();
        rep101_qryObjects.Close();
        rep101_qryPrepData.Close();
        rep_objCount++;

        if (rep101_needRep && (rep_objCount % rep_objsPerFile == 0))
          Rep_SavePrepared();

        Rep_DisplayProgress();
        Rep_SetFirstTask();
        continue;
      }

      case REP_ST_COMPLETE:
      {
        if (rep101_needRep && !rep_isSaved) Rep_SavePrepared();
        Rep101_Uninit();
        //   
        if (rep101_needRep) Rep_SelectPrepared("Rep101");
        if (rep101_needExport)
          ShellExecute(GetDesktopWindow(), "open", rep101_expDir, "", "", SW_SHOWNORMAL);
        return;
      }
    }
}

//     (RetVal- )
void Rep101_OnComplete(int RetVal)
{
  try
  {
    Rep_ProcessRetVal(RetVal);

    switch (rep_task)
    {
      case REP101_ST_SUMMARY:
        Rep_SetNextTask();

      case REP101_ST_LOG:
        rep101_qryVDevices.Next();
    }

    Rep101_PrepareNext();
  }
  except
  {
    Rep_ReportException();
    Rep_SetTask(REP_ST_COMPLETE);
    Rep101_PrepareNext();
  }
}

//    
void Rep101_Start()
{
  try
  {
    if (!Rep_Init("Rep101")) return;

    //      
    Rep_LoadTemplate(rep_tmplDir + "Rep101_Params.fr3");
    frPrepare(1);

    //    ""  
    if (!rep_dlgResult)
    {
      Rep_Uninit();
      return;
    }

    Rep101_Init();
    Rep_SetFirstTask();
    Rep101_PrepareNext();
  }
  except
  {
    Rep_ReportException();
    Rep101_Uninit();
  }
}

// -------------------
//  
// -------------------

// /   
void Rep101_cmdStartOnClick(TMonText Sender)
{
  Rep101_Start();
}

//     
void Rep101_cmdSelPreparedOnClick(TMonText Sender)
{
  Rep_SelectPrepared("Rep101");
}

//     main()
{
}

