#include "PROGRAM\\Reports.cpp"

#define REP103_ST_OBJINIT 0
#define REP103_ST_EXPORT 1
#define REP103_ST_OBJCOMPLETE 2

TDateTime rep103_sdt; //  /
TDateTime rep103_edt; //  /

//  
string rep103_expDir;

TADOQuery rep103_qryPrepData;
TADOQuery rep103_qryExpData;

string rep103_qryPrepDataSQL1;
string rep103_qryPrepDataSQL2;
string rep103_qryExpDataSQL;

void Rep103_ClearPrepared()
{
  DeleteFile(rep103_expDir + "*.csv");
}

void Rep103_InitVars()
{
  Rep103_cmdStart.Text = "   ";
  rep103_expDir = rep_frDir + "Export\\MVK\\";

  rep103_qryPrepData = nil;
  rep103_qryExpData = nil;

  rep103_qryPrepDataSQL1 = "SELECT rep103_init('%s', '%s')";
  rep103_qryPrepDataSQL2 = "SELECT rep103_prep_expdata()";
  rep103_qryExpDataSQL = "SELECT * FROM tmp_rep103_expdata ORDER BY wsclientid, cnumber, winputnum";
}

void Rep103_InitTasks()
{
  rep_tasks[0] = REP103_ST_OBJINIT;
  rep_tasks[1] = REP103_ST_EXPORT;
  rep_tasks[2] = REP103_ST_OBJCOMPLETE;
}

void Rep103_InitObjects()
{
  //     
  rep103_qryPrepData = new TADOQuery(nil);
  rep103_qryPrepData.Connection = SystemADOConnection;
  rep103_qryPrepData.LockType = 1;
  rep103_qryPrepData.SQL.Text = Format(rep103_qryPrepDataSQL1,
    [
      FormatDateTime("yyyy-mm-dd hh:nn:ss", rep103_sdt),
      FormatDateTime("yyyy-mm-dd hh:nn:ss", rep103_edt),
    ]);

  //   
  rep103_qryPrepData.Open();
  rep103_qryPrepData.Close();

  rep103_qryPrepData.SQL.Text = rep103_qryPrepDataSQL2;

  //   
  rep103_qryExpData = new TADOQuery(nil);
  rep103_qryExpData.Connection = SystemADOConnection;
  rep103_qryExpData.SQL.Text = rep103_qryExpDataSQL;
}

void Rep103_UninitObjects()
{
  if (rep103_qryPrepData != nil) {delete rep103_qryPrepData; rep103_qryPrepData = nil;}
  if (rep103_qryExpData != nil) {delete rep103_qryExpData; rep103_qryExpData = nil;}
}

//    
void Rep103_Init()
{
  Rep_InitProgress(1, Rep103_cmdStart);
  Rep_DisplayProgress();
  Rep103_ClearPrepared();
  Rep103_InitTasks();
  Rep103_InitObjects();
}

//    
void Rep103_Uninit()
{
  Rep_UninitProgress(Rep103_cmdStart);
  Rep103_UninitObjects();
  Rep_Uninit();
}

//    
void Rep103_ExportData()
{
  try
  {
    try
    {
      string expFilePath = rep103_expDir + "u_%s.csv";
      TFileStream expFile = nil;
      string curWSClientID = "";
      string wsClientID = "";

      rep103_qryExpData.Open();

      for (; !rep103_qryExpData.EOF; rep103_qryExpData.Next())
      {
        wsClientID = rep103_qryExpData.FieldByName("wsclientid").Value;

        if (wsClientID != curWSClientID)
        {
          if (expFile != nil) delete expFile;
          expFile = new TFileStream(Format(expFilePath, [wsClientID]), fmCreate);
          curWSClientID = wsClientID;
        }

        string s = Format("%s;%s;%s;%s;%1.0f;%s;%s\r\n",
          [wsClientID,
          rep103_qryExpData.FieldByName("cnumber").Value,
          rep103_qryExpData.FieldByName("f").Value,
          rep103_qryExpData.FieldByName("winputnum").Value,
          rep103_qryExpData.FieldByName("v").Value,
          FormatDateTime("yyyymmdd", rep103_qryExpData.FieldByName("sdt").Value),
          FormatDateTime("yyyymmdd", rep103_qryExpData.FieldByName("edt").Value)]);

        expFile.Write(s, Length(s));
      }
    }
    except
    {
      Rep_ReportException();
    }
  }
  finally
  {
    if (expFile != nil) delete expFile;
    rep103_qryExpData.Close();
  }
}

//    
void Rep103_PrepareNext()
{
  int objID;
  TfrxMasterData b;

  while (true)
    switch (rep_task)
    {
      case REP103_ST_OBJINIT:
      {
        if (rep_objCount >= rep_totalObjs)
        {
          Rep_SetTask(REP_ST_COMPLETE);
          continue;
        }

        try
        {
          rep103_qryPrepData.Open();
        }
        except
        {
          Rep_ReportException();
          Rep_SetTask(REP103_ST_OBJCOMPLETE);
          continue;
        }

        Rep_SetNextTask();
        continue;
      }

      case REP103_ST_EXPORT:
      {
        Rep103_ExportData();
        Rep_SetNextTask();
        continue;
      }

      case REp103_ST_OBJCOMPLETE:
      {
        rep103_qryPrepData.Close();
        rep_objCount++;
        Rep_DisplayProgress();
        Rep_SetFirstTask();
        continue;
      }

      case REP_ST_COMPLETE:
      {
        Rep103_Uninit();
        ShellExecute(GetDesktopWindow(), "open", rep103_expDir, "", "", SW_SHOWNORMAL);
        Rep_ReportInfo("  ");
        return;
      }
    }
}

//    
void rep103_Start()
{
  try
  {
    if (!Rep_Init("Rep103")) return;
    //      
    Rep_LoadTemplate(rep_tmplDir + "Rep103_Params.fr3");
    frPrepare(1);

    //    ""  
    if (!rep_dlgResult)
    {
      Rep_Uninit();
      return;
    }

    Rep103_Init();
    Rep_SetFirstTask();
    Rep103_PrepareNext();
  }
  except
  {
    Rep_ReportException();
    Rep103_Uninit();
  }
}

// -------------------
//  
// -------------------

// /   
void Rep103_cmdStartOnClick(TMonText Sender)
{
  Rep103_Start();
}

//     main()
{
}

