#include "PROGRAM\\Reports.cpp"

#define REP301_ST_OBJINIT 0
#define REP301_ST_LOG 1
#define REP301_ST_OBJCOMPLETE 2
#define REP301_ST_SUMMARY 3

//     "Rep301_Params.fr3"
//     
int rep301_timeIntID; //   
TDateTime rep301_sdt; //  /
TDateTime rep301_edt; //  /
Variant rep301_objArray; //     
bool rep301_needSummary; //   
bool rep301_needLog; //   

//  
bool rep301_needRep;
string rep301_expDir;

TADOQuery rep301_qryPrepData;
TADOQuery rep301_qryParams;
TADOQuery rep301_qryVDevices;
TADOQuery rep301_qrySummary;
TADOQuery rep301_qrySummaryAgr;
TADOQuery rep301_qryLog;
TADOQuery rep301_qryLogAgr;
TADOQuery rep301_qryInt;
TADOQuery rep301_qryIntAgr;

TfrxDBDataset rep301_dsParams;
TfrxDBDataset rep301_dsVDevices;
TfrxDBDataset rep301_dsSummary;
TfrxDBDataset rep301_dsSummaryAgr;
TfrxDBDataset rep301_dsLog;
TfrxDBDataset rep301_dsLogAgr;
TfrxDBDataset rep301_dsInt;
TfrxDBDataset rep301_dsIntAgr;

string rep301_qryPrepDataSQL1;
string rep301_qryPrepDataSQL2;
string rep301_qryPrepDataSQL3;
string rep301_qryParamsSQL;
string rep301_qryVDevicesSQL;
string rep301_qrySummarySQL;
string rep301_qrySummaryAgrSQL;
string rep301_qryLogSQL;
string rep301_qryLogAgrSQL;
string rep301_qryIntSQL;
string rep301_qryIntAgrSQL;

void Rep301_ClearPrepared()
{
  DeleteFile(rep_prepDir + rep_repID + "\\Part*.fp3");
  DeleteFile(rep_prepDir + rep_repID + "\\Files.csv");
}

void Rep301_InitVars()
{
  rep301_cmdStart.Text = "";

  rep301_qryPrepData = nil;
  rep301_qryParams = nil;
  rep301_qryVDevices = nil;
  rep301_qrySummary = nil;
  rep301_qrySummaryAgr = nil;
  rep301_qryLog = nil;
  rep301_qryLogAgr = nil;
  rep301_qryInt = nil;
  rep301_qryIntAgr = nil;

  rep301_dsParams = nil;
  rep301_dsVDevices = nil;
  rep301_dsSummary = nil;
  rep301_dsSummaryAgr = nil;
  rep301_dsLog = nil;
  rep301_dsLogAgr = nil;
  rep301_dsInt = nil;
  rep301_dsIntAgr = nil;

  rep301_qryPrepDataSQL1 = "SELECT rep301_init('%s', '%s', %s, %s)";
  rep301_qryPrepDataSQL2 = "SELECT rep301_prep_object(:objid)";
  rep301_qryPrepDataSQL3 = "SELECT rep301_prep_summary()";
  rep301_qryParamsSQL = "SELECT * FROM tmp_rep301_params";
  rep301_qryVDevicesSQL =
    "SELECT * FROM tmp_rep301_vdevices WHERE objid = :objid ORDER BY vdevnum";
  rep301_qrySummarySQL =
    "SELECT * FROM tmp_rep301_summary WHERE vdevnum IS NOT NULL ORDER BY vdevnum";
  rep301_qrySummaryAgrSQL =
    "SELECT * FROM tmp_rep301_summary WHERE vdevnum IS NULL";
  rep301_qryLogSQL =
    "SELECT * FROM tmp_rep301_log WHERE vdevnum = :vdevnum AND dt IS NOT NULL ORDER BY dt";
  rep301_qryLogAgrSQL =
    "SELECT * FROM tmp_rep301_log WHERE vdevnum = :vdevnum AND dt IS NULL";
  rep301_qryIntSQL =
    "SELECT * FROM tmp_rep301_int WHERE vdevnum = :vdevnum AND dt IS NOT NULL ORDER BY dt DESC";
  rep301_qryIntAgrSQL =
    "SELECT * FROM tmp_rep301_int WHERE vdevnum = :vdevnum AND dt IS NULL";
}

void Rep301_InitTasks()
{
  int i = 0; rep_tasks[i] = REP301_ST_OBJINIT;
  if (rep301_needLog) {i++; rep_tasks[i] = REP301_ST_LOG;}
  i++; rep_tasks[i] = REP301_ST_OBJCOMPLETE;
  if (rep301_needSummary) {i++; rep_tasks[i] = REP301_ST_SUMMARY;}
}

void Rep301_InitCommonObjects()
{
  //     
  rep301_qryPrepData = new TADOQuery(nil);
  rep301_qryPrepData.Connection = SystemADOConnection;
  rep301_qryPrepData.LockType = 1;
  rep301_qryPrepData.SQL.Text = Format(rep301_qryPrepDataSQL1,
    [
      FormatDateTime("yyyy-mm-dd hh:nn:ss", rep301_sdt),
      FormatDateTime("yyyy-mm-dd hh:nn:ss", rep301_edt),
      Rep_GetBoolStr(rep301_needSummary),
      Rep_GetBoolStr(rep301_needLog)
    ]);

  //   
  rep301_qryPrepData.Open();
  rep301_qryPrepData.Close();

  rep301_qryPrepData.SQL.Text = rep301_qryPrepDataSQL2;
  rep301_qryPrepData.Parameters.Items[0].DataType = ftInteger;

  //  
  rep301_qryVDevices = new TADOQuery(nil);
  rep301_qryVDevices.Connection = SystemADOConnection;
  rep301_qryVDevices.SQL.Text = rep301_qryVDevicesSQL;
  rep301_qryVDevices.Parameters.Items[0].DataType = ftInteger;

  rep301_dsVDevices = new TfrxDBDataset(nil);
  rep301_dsVDevices.DataSet = rep301_qryVDevices;
  rep301_dsVDevices.Name = "dsVDevices";
}

void Rep301_UninitCommonObjects()
{
  if (rep301_qryPrepData != nil) {delete rep301_qryPrepData; rep301_qryPrepData = nil;}
  if (rep301_qryVDevices != nil) {delete rep301_qryVDevices; rep301_qryVDevices = nil;}
  if (rep301_dsVDevices != nil) {delete rep301_dsVDevices; rep301_dsVDevices = nil;}
}

void Rep301_InitSummaryObjects()
{
  if (!rep301_needSummary) return;

  //   
  rep301_qryParams = new TADOQuery(nil);
  rep301_qryParams.Connection = SystemADOConnection;
  rep301_qryParams.SQL.Text = rep301_qryParamsSQL;

  rep301_dsParams = new TfrxDBDataset(nil);
  rep301_dsParams.DataSet = rep301_qryParams;
  rep301_dsParams.Name = "dsParams";

  //     
  rep301_qrySummary = new TADOQuery(nil);
  rep301_qrySummary.Connection = SystemADOConnection;
  rep301_qrySummary.SQL.Text = rep301_qrySummarySQL;

  rep301_dsSummary = new TfrxDBDataset(nil);
  rep301_dsSummary.DataSet = rep301_qrySummary;
  rep301_dsSummary.Name = "dsSummary";
  rep301_dsSummary.CloseDataSource = true;

  //     
  rep301_qrySummaryAgr = new TADOQuery(nil);
  rep301_qrySummaryAgr.Connection = SystemADOConnection;
  rep301_qrySummaryAgr.SQL.Text = rep301_qrySummaryAgrSQL;

  rep301_dsSummaryAgr = new TfrxDBDataset(nil);
  rep301_dsSummaryAgr.DataSet = rep301_qrySummaryAgr;
  rep301_dsSummaryAgr.Name = "dsSummaryAgr";
  rep301_dsSummaryAgr.CloseDataSource = true;
}

void Rep301_UninitSummaryObjects()
{
  if (!rep301_needSummary) return;

  if (rep301_qryParams != nil) {delete rep301_qryParams; rep301_qryParams = nil;}
  if (rep301_dsParams != nil) {delete rep301_dsParams; rep301_dsParams = nil;}

  if (rep301_qrySummary != nil) {delete rep301_qrySummary; rep301_qrySummary = nil;}
  if (rep301_dsSummary != nil) {delete rep301_dsSummary; rep301_dsSummary = nil;}

  if (rep301_qrySummaryAgr != nil) {delete rep301_qrySummaryAgr; rep301_qrySummaryAgr = nil;}
  if (rep301_dsSummaryAgr != nil) {delete rep301_dsSummaryAgr; rep301_dsSummaryAgr = nil;}
}

void Rep301_InitLogObjects()
{
  if (!rep301_needLog) return;

  //  
  rep301_qryLog = new TADOQuery(nil);
  rep301_qryLog.Connection = SystemADOConnection;
  rep301_qryLog.SQL.Text = rep301_qryLogSQL;
  rep301_qryLog.Parameters.Items[0].DataType = ftInteger;

  rep301_dsLog = new TfrxDBDataset(nil);
  rep301_dsLog.DataSet = rep301_qryLog;
  rep301_dsLog.Name = "dsLog";
  rep301_dsLog.CloseDataSource = true;

  //   ()
  rep301_qryLogAgr = new TADOQuery(nil);
  rep301_qryLogAgr.Connection = SystemADOConnection;
  rep301_qryLogAgr.SQL.Text = rep301_qryLogAgrSQL;
  rep301_qryLogAgr.Parameters.Items[0].DataType = ftInteger;

  rep301_dsLogAgr = new TfrxDBDataset(nil);
  rep301_dsLogAgr.DataSet = rep301_qryLogAgr;
  rep301_dsLogAgr.Name = "dsLogAgr";
  rep301_dsLogAgr.CloseDataSource = true;

  // 
  rep301_qryInt = new TADOQuery(nil);
  rep301_qryInt.Connection = SystemADOConnection;
  rep301_qryInt.SQL.Text = rep301_qryIntSQL;
  rep301_qryInt.Parameters.Items[0].DataType = ftInteger;

  rep301_dsInt = new TfrxDBDataset(nil);
  rep301_dsInt.DataSet = rep301_qryInt;
  rep301_dsInt.Name = "dsInt";
  rep301_dsInt.CloseDataSource = true;

  //  ()
  rep301_qryIntAgr = new TADOQuery(nil);
  rep301_qryIntAgr.Connection = SystemADOConnection;
  rep301_qryIntAgr.SQL.Text = rep301_qryIntAgrSQL;
  rep301_qryIntAgr.Parameters.Items[0].DataType = ftInteger;

  rep301_dsIntAgr = new TfrxDBDataset(nil);
  rep301_dsIntAgr.DataSet = rep301_qryIntAgr;
  rep301_dsIntAgr.Name = "dsIntAgr";
  rep301_dsIntAgr.CloseDataSource = true;
}

void Rep301_UninitLogObjects()
{
  if (!rep301_needLog) return;

  if (rep301_qryLog != nil) {delete rep301_qryLog; rep301_qryLog = nil;}
  if (rep301_dsLog != nil) {delete rep301_dsLog; rep301_dsLog = nil;}
  if (rep301_qryLogAgr != nil) {delete rep301_qryLogAgr; rep301_qryLogAgr = nil;}
  if (rep301_dsLogAgr != nil) {delete rep301_dsLogAgr; rep301_dsLogAgr = nil;}
  if (rep301_qryInt != nil) {delete rep301_qryInt; rep301_qryInt = nil;}
  if (rep301_dsInt != nil) {delete rep301_dsInt; rep301_dsInt = nil;}
  if (rep301_qryIntAgr != nil) {delete rep301_qryIntAgr; rep301_qryIntAgr = nil;}
  if (rep301_dsIntAgr != nil) {delete rep301_dsIntAgr; rep301_dsIntAgr = nil;}
}

//    
void Rep301_Init()
{
  Rep_InitProgress(Length(rep301_objArray), Rep301_cmdStart);
  Rep_DisplayProgress();

  Rep301_ClearPrepared();
  rep301_needRep = rep301_needSummary || rep301_needLog;
  if (rep301_needRep) Rep_InitPrepared();

  Rep301_InitTasks();

  Rep301_InitCommonObjects();
  Rep301_InitSummaryObjects();
  Rep301_InitLogObjects();
}

//    
void Rep301_Uninit()
{
  Rep_UninitProgress(Rep301_cmdStart);
  if (rep301_needRep) Rep_UninitPrepared();

  Rep301_UninitCommonObjects();
  Rep301_UninitSummaryObjects();
  Rep301_UninitLogObjects();

  Rep_Uninit();
}

//    
void Rep301_PrepareNext()
{
  int objID;
  string fullAddr;
  string objName;
  TfrxMasterData b;

  while (true)
    switch (rep_task)
    {
      case REP301_ST_OBJINIT:
      {
        ProcessMessages();

        if (rep_break)
        {
          Rep_ReportInfo(REP_MSG_USERBREAK);
          Rep_SetTask(REP_ST_COMPLETE);
          continue;
        }

        if (rep_objCount >= rep_totalObjs)
        {
          if (rep301_needSummary)
          {
            if (!rep_isSaved) Rep_SavePrepared();
            Rep_SetTask(REP301_ST_SUMMARY);
          }
          else
            Rep_SetTask(REP_ST_COMPLETE);

          continue;
        }

        objID = rep301_objArray[rep_objCount];
        rep301_qryPrepData.Parameters.Items[0].Value = objID;

        try
        {
          rep301_qryPrepData.Open();
        }
        except
        {
          Rep_ReportException();
          Rep_SetTask(REP301_ST_OBJCOMPLETE);
          continue;
        }

        rep301_qryVDevices.Parameters.Items[0].Value = objID;
        rep301_qryVDevices.Open();

        fullAddr = rep301_qryVDevices.FieldByName("addr").AsString;
        objName = rep301_qryVDevices.FieldByName("objname").AsString;
        if (Length(objName) > 0) fullAddr = fullAddr + " " + objName;
        Rep_WriteLog(fullAddr);

        if (rep301_needLog && (rep_objCount % rep_objsPerFile == 0))
          rep_firstObjName = fullAddr;

        Rep_SetNextTask();
        continue;
      }

      case REP301_ST_LOG:
      {
        if (rep301_qryVDevices.EOF)
        {
          Rep_SetNextTask();
          continue;
        }

        Rep_WriteLog
        (
          rep301_qryVDevices.FieldByName("typename").AsString + ", " +
          " " + rep301_qryVDevices.FieldByName("sernum").AsString
        );

        rep_newTmplFileName = "Rep301.fr3";

        int vDevNum = AsInteger(rep301_qryVDevices.FieldByName("vdevnum").Value);
        rep301_qryLog.Parameters.Items[0].Value = vDevNum;
        rep301_qryLogAgr.Parameters.Items[0].Value = vDevNum;
        rep301_qryInt.Parameters.Items[0].Value = vDevNum;
        rep301_qryIntAgr.Parameters.Items[0].Value = vDevNum;

        //   
        if (rep_newTmplFileName != rep_curTmplFileName)
        {
          if (!Rep_LoadTemplate(rep_tmplDir + rep_newTmplFileName))
          {
            rep301_qryVDevices.Next();
            continue;
          }

          //     
          SystemReport.DataSets.Add(rep301_dsVDevices);
          SystemReport.DataSets.Add(rep301_dsLog);
          SystemReport.DataSets.Add(rep301_dsLogAgr);
          SystemReport.DataSets.Add(rep301_dsInt);
          SystemReport.DataSets.Add(rep301_dsIntAgr);
          //     
          b = TfrxMasterData(SystemReport.FindObject("bandLog"));
          if (b != nil) b.DataSet = rep301_dsLog;
          b = TfrxMasterData(SystemReport.FindObject("bandInt"));
          if (b != nil) b.DataSet = rep301_dsInt;
        }

        //      () 
        Rep_AsyncPrepare(rep_isSaved, "Rep301_OnComplete");
        return;
      }

      case REP301_ST_OBJCOMPLETE:
      {
        rep301_qryVDevices.Close();
        rep301_qryPrepData.Close();
        rep_objCount++;

        if ((rep_objCount % rep_objsPerFile == 0) && !rep_isSaved)
          Rep_SavePrepared();

        Rep_DisplayProgress();
        Rep_SetFirstTask();
        continue;
      }

      case REP301_ST_SUMMARY:
      {
        Rep_WriteLog(" ...");
        //   
        rep_newTmplFileName = "Rep301_Summary.fr3";

        if (rep_newTmplFileName != rep_curTmplFileName)
        {
          if (!Rep_LoadTemplate(rep_tmplDir + rep_newTmplFileName))
          {
            Rep_SetTask(REP_ST_COMPLETE);
            continue;
          }

          //     
          SystemReport.DataSets.Add(rep301_dsParams);
          SystemReport.DataSets.Add(rep301_dsSummary);
          SystemReport.DataSets.Add(rep301_dsSummaryAgr);
          //     
          b = TfrxMasterData(SystemReport.FindObject("bandSummary"));
          if (b != nil) b.DataSet = rep301_dsSummary;
        }

        //    
        rep301_qryPrepData.Close();
        rep301_qryPrepData.SQL.Text = rep301_qryPrepDataSQL3;
        rep301_qryPrepData.Open();

        rep301_qryParams.Open();
        rep_firstObjName = " ";
        //      () 
        Rep_AsyncPrepare(rep_isSaved, "Rep301_OnComplete");
        return;
      }

      case REP_ST_COMPLETE:
      {
        if (!rep_isSaved) Rep_SavePrepared();
        Rep301_Uninit();
        //   
        if (rep301_needRep) Rep_SelectPrepared("Rep301");
        return;
      }
    }
}

//     (RetVal- )
void Rep301_OnComplete(int RetVal)
{
  try
  {
    Rep_ProcessRetVal(RetVal);

    switch (rep_task)
    {
      case REP301_ST_LOG:
        rep301_qryVDevices.Next();

      case REP301_ST_SUMMARY:
        Rep_SetTask(REP_ST_COMPLETE);
    }

    Rep301_PrepareNext();
  }
  except
  {
    Rep_ReportException();
    Rep_SetTask(REP_ST_COMPLETE);
    Rep301_PrepareNext();
  }
}

//    
void Rep301_Start()
{
  try
  {
    if (!Rep_Init("Rep301")) return;

    //      
    Rep_LoadTemplate(rep_tmplDir + "Rep301_Params.fr3");
    frPrepare(1);

    //    ""  
    if (!rep_dlgResult)
    {
      Rep_Uninit();
      return;
    }

    Rep301_Init();
    Rep_SetFirstTask();
    Rep301_PrepareNext();
  }
  except
  {
    Rep_ReportException();
    Rep301_Uninit();
  }
}

// -------------------
//  
// -------------------

// /   
void Rep301_cmdStartOnClick(TMonText Sender)
{
  Rep301_Start();
}

//     
void Rep301_cmdSelPreparedOnClick(TMonText Sender)
{
  Rep_SelectPrepared("Rep301");
}

//     main()
{
}
